//+------------------------------------------------------------------+
//|                                                          Z1.mq4 |
//|                                          Copyright  2007, .Beno |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, .Beno"
#property link      ""
#include <stdlib.mqh>

extern int expertId=197893;
extern string EAName="Z1";
extern double ProfitExit = 0.05; //% profit exit
//extern double TrailingStop = 30;
extern string PARAMETERS_FILTER = "PARAMETERS FILTER";
extern bool UseHourTrade = False;
extern int FromHourTrade = 8;
extern int ToHourTrade = 120;

extern int       barsToCount = 2000;
extern double        UpperTarget1 = 1.0;
extern double        LowerTarget1 = -1.0;
extern int TakeProfit1=150;
extern int TakeProfit2=150;
extern int _3bartrailpips=100;
extern int BreakEven=10;
extern int StopLoss=0;  
extern int  OrderPipsDiff=5;


extern double Lots = 0.01;  
extern double MaximumRisk = 2;
extern int    LotDigits = 1;  
extern bool   FixedLot = true;

extern int    slippage=2;   	//slippage for market order 
int    shift=0;			//shift to current bar
extern int    OrderTriesNumber=2; //to repeate sending orders when got some error


bool exit,remorder, sellsig1, sellsig2, sellsig3, sellsig4, sellsig5, sellsig6, buysig1, buysig2, buysig3, buysig4, buysig5, buysig6, closebuy1, closesell1, closebuy2, closesell2, closebuy3, closesell3, closebuy4, closesell4, closebuy5, closesell5, closebuy6, closesell6;
int last,buys,sells,co,mkt,lastsig,tries,bres;
double curprof,LotsRisk;




//+------------------------------------------------------------------+
//| Calculate open positions                                         |
//+------------------------------------------------------------------+
int CalculateCurrentOrders(string symbol)
  {
   int ord; mkt=0;
//----
   for(int i=0;i<OrdersTotal();i++)  {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false) continue;
      if(OrderSymbol()==symbol && OrderMagicNumber()==expertId) {
         ord++;
         if (OrderType()==OP_BUY || OrderType()==OP_SELL) mkt++;
      }
   }
//---- return orders volume
   return(ord);
}

//+------------------------------------------------------------------+
//| Check for open order conditions                                  |
//+------------------------------------------------------------------+
void CheckForSignals() {

   	


   	double zscore5=iCustom(NULL,5,"zscore6",barsToCount,PRICE_CLOSE,1);
   	double zscore15=iCustom(NULL,15,"zscore6",barsToCount,PRICE_CLOSE,2);
   	double zscore30=iCustom(NULL,30,"zscore6",barsToCount,PRICE_CLOSE,3);
   	double zscore60=iCustom(NULL,60,"zscore6",barsToCount,PRICE_CLOSE,4);
   	double zscore240=iCustom(NULL,240,"zscore6",barsToCount,PRICE_CLOSE,5);
   	double zscore1440=iCustom(NULL,1440,"zscore6",barsToCount,PRICE_CLOSE,6);



      buysig1 = false;
      sellsig1 = false;
      buysig2 = false;
      sellsig2 = false;
      buysig3 = false;
      sellsig3 = false;
      buysig4 = false;
      sellsig4 = false;
      buysig5 = false;
      sellsig5 = false;
      buysig6 = false;
      sellsig6 = false;
      closebuy1=false;
      closesell1=false;
      closebuy2=false;
      closesell2=false;
      closebuy3=false;
      closesell3=false;
      closebuy4=false;
      closesell4=false;
      closebuy5=false;
      closesell5=false;
      closebuy6=false;
      closesell6=false;
      exit=false;
   
    
      double HL1=UpperTarget1;
      double HL2=LowerTarget1;

   

    
      bool Long1 = zscore5 > HL1;
      bool Short1 = zscore5 < HL2;
      bool Long2 = zscore15 > HL1;
      bool Short2 = zscore15 < HL2;
      bool Long3 = zscore30 > HL1;
      bool Short3 = zscore30 < HL2;
      bool Long4 = zscore60 > HL1;
      bool Short4 = zscore60 < HL2;
      bool Long5 = zscore240 > HL1;
      bool Short5 = zscore240 < HL2;
      bool Long6 = zscore1440 > HL1;
      bool Short6 = zscore1440 < HL2;


      buysig1 = Long1;
      sellsig1 = Short1;
      buysig2 = Long2;
      sellsig2 = Short2;
      buysig3 = Long3;
      sellsig3 = Short3;
      buysig4 = Long4;
      sellsig4 = Short4;
      buysig5 = Long5;
      sellsig5 = Short5;
      buysig6 = Long6;
      sellsig6 = Short6;

      closebuy1=sellsig1;
      closesell1=buysig1;
      closebuy2=sellsig2;
      closesell2=buysig2;
      closebuy3=sellsig3;
      closesell3=buysig3;
      closebuy4=sellsig4;
      closesell4=buysig4;
      closebuy5=sellsig5;
      closesell5=buysig5 ;
      closebuy6=sellsig6;
      closesell6=buysig6;
      

      if (curprof>=AccountBalance()*ProfitExit/100.0) {
         exit=true;
      }
}

void CheckForOpen() {

   if (last==Time[0]) return;

   int    res,ord,tr;
   double entry,stop,profit;
   
  



//---- sell conditions
   co=CalculateCurrentOrders(Symbol());
   if(sellsig1 || sellsig2 || sellsig3 || sellsig4 || sellsig5 || sellsig6 && lastsig!=-1)  {
      co=CalculateCurrentOrders(Symbol());
	   if (co==0) {
        res = OpenStop(OP_SELLSTOP,LotsRisk(StopLoss), Low[shift]-OrderPipsDiff*Point, StopLoss, TakeProfit1);
        res = OpenStop(OP_SELLSTOP,LotsRisk(StopLoss), Low[shift]-OrderPipsDiff*Point, StopLoss, TakeProfit2);
	   }
	   lastsig=-1;
	   last=Time[0];
      return;
   }
//---- buy conditions
   if(buysig1 || buysig2 || buysig3 || buysig4 || buysig5 || buysig6 && lastsig!=1)  {
      co=CalculateCurrentOrders(Symbol());
	   if (co==0) {
        res = OpenStop(OP_BUYSTOP,LotsRisk(StopLoss), High[shift]+OrderPipsDiff*Point, StopLoss, TakeProfit1);
        res = OpenStop(OP_BUYSTOP,LotsRisk(StopLoss), High[shift]+OrderPipsDiff*Point, StopLoss, TakeProfit2);
	   }
	   last=Time[0];
	   lastsig=1;
      return;
   }
}
  

   
   void BreakEvenStop(int BES, int BELP) {
   //move stoploss to lock some profit
   bool bres;
   double StopLoss;
   if ( BES > 2 ) {
      for (int i = 0; i < OrdersTotal(); i++) {
         if ( OrderSelect (i, SELECT_BY_POS) == false )  continue;
         if ( OrderSymbol() != Symbol() || OrderMagicNumber() != expertId )  continue;
         if ( OrderType() == OP_BUY ) {
            if ( Bid < OrderOpenPrice()+BES*Point )  continue;
            StopLoss = OrderOpenPrice()+BELP*Point;
            if ( StopLoss > OrderStopLoss() ) {
                  bres=OrderModify (OrderTicket(), OrderOpenPrice(), StopLoss, OrderTakeProfit(), 0, White);
					   if (!bres) Print("Error Modifying BUY order : ",ErrorDescription(GetLastError()));
            }
         }
   
         if ( OrderType() == OP_SELL ) {
            if ( Ask > OrderOpenPrice()-BES*Point )  continue;
            StopLoss = OrderOpenPrice()-BELP*Point;
            if ( StopLoss < OrderStopLoss() ) {
                  bres=OrderModify (OrderTicket(), OrderOpenPrice(), StopLoss, OrderTakeProfit(), 0, Gold);
					   if (!bres) Print("Error Modifying SELL order : ",ErrorDescription(GetLastError()));
            }
         }
      }
   }
   return;
   
   }

int OpenStop(int mode,double lot, double prc, int SL, int TP) {
   int    res,tr,col;
   string mail;
   double openprice,sl,tp,stlev;
   tries=0;
   stlev=(1+MarketInfo(Symbol(),MODE_STOPLEVEL))*Point;
   while (res<=0 && tries<OrderTriesNumber) {
      tr=0; while (tr<5 && !IsTradeAllowed()) { tr++; Sleep(2000); }
      RefreshRates();
      if (mode==OP_SELLSTOP) {
         if (prc<=Bid-stlev) openprice=prc; 
         else openprice=Bid-stlev; 
         if (SL>0) sl=openprice+SL*Point;
         if (TP>0) tp=openprice-TP*Point;
         col=Red;
      } else
      if (mode==OP_BUYSTOP) {
         if (prc>=Ask+stlev) openprice=prc; 
         else openprice=Ask+stlev; 
         if (SL>0) sl=openprice-SL*Point;
         if (TP>0) tp=openprice+TP*Point;
         col=Blue;
      } else return;
      Print(Ask," ",Bid," ",Symbol(),"  ",mode,"  ",lot,"  ",openprice,"  ",sl,"  ",tp,"  ");
      res=OrderSend(Symbol(),mode,lot,openprice,slippage,sl,tp,EAName+"_"+expertId,expertId,0,col);
      tries++;
   }
   if (res<=0) Print("Error opening pending order : ",ErrorDescription(GetLastError()));
   return(res);
}

void CheckForClose()  {
   bool bres; int tr;
   for(int i=0;i<OrdersTotal();i++)  {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false)  continue;
      if(OrderMagicNumber()!=expertId || OrderSymbol()!=Symbol()) continue;
      //---- check order type 
      if(OrderType()==OP_BUY && exit || closebuy1 || closebuy2 || closebuy3 || closebuy4 || closebuy5 || closebuy6 ) {
         bres=CloseAtMarket(OrderTicket(),OrderLots());
         continue;
      }
      if(OrderType()==OP_SELL && exit || closesell1 || closesell2 || closesell3 || closesell4 || closesell5 || closesell6 ) {
         bres=CloseAtMarket(OrderTicket(),OrderLots());
         continue;
      }
      if(OrderType()==OP_BUYSTOP && (remorder)) {
         bres=DeletePending(OrderTicket());
         continue;
      }
      if(OrderType()==OP_SELLSTOP && (remorder)) {
         bres=DeletePending(OrderTicket());
         continue;
      }
   }
}

bool DeletePending(int ticket) {
   bool bres=false; int tr;
   tries=0;
   while (!bres && tries<OrderTriesNumber) {
      bres=OrderDelete(ticket);
      tries++;
      tr=0; while (tr<5 && !IsTradeAllowed()) { tr++; Sleep(2000); }
   }
   if (!bres) Print("Error deleting order : ",ErrorDescription(GetLastError()));
   return (bres);
}

bool CloseAtMarket(int ticket,double lot) {
   //fault tolerant market order closing
   bool bres=false; int tr;
   tries=0;
   while (!bres && tries<OrderTriesNumber) {
      RefreshRates();
      bres=OrderClose(ticket,lot,OrderClosePrice(),slippage,White);
      tries++;
      tr=0; while (tr<5 && !IsTradeAllowed()) { tr++; Sleep(2000); }
   }
   if (!bres) Print("Error closing order : ",ErrorDescription(GetLastError()));
}


double LotsRisk(int StopLoss)  { 
   double lot=Lots;
   int SL=StopLoss;
   if (SL==0) SL=100;
//---- select lot size
   if (!FixedLot)
      lot=AccountFreeMargin()*MaximumRisk*0.001/SL;
   lot=NormalizeDouble(lot,LotDigits);
//---- return lot size
   if(lot<MarketInfo(Symbol(),MODE_MINLOT)) lot=MarketInfo(Symbol(),MODE_MINLOT);
   return(lot);
}

//3 bar trailing stop count back 3 bar and place a stop loss 2 pips below the lowest bar when counting back do not count the inside bars 
//skip to the next bar,  when a new bar opens perform the same task and move the trailing stop loss if able to. 
//If due to broker stop loss restrictions place the stop as close as possible to the next bar target and move it until 
//the next bar target is hit then repeat for each new bar

void Trail3Bar() {
   //_3bartrailpips
   bool bres;
   double StopLoss,H3,L3=99999;
   int i=0,cnt=3;
   
   while (i<=cnt) {
      i++;
      if (i>Bars-1) break;
      if (High[i]<=High[i+1] && Low[i]>=Low[i+1]) { cnt++; continue; } //skip inside Bar
      H3=MathMax(H3,High[i]);
      L3=MathMin(L3,Low[i]);
   }
   L3=L3-_3bartrailpips*Point;
   H3=H3+_3bartrailpips*Point;
   double stlev=(1+MarketInfo(Symbol(),MODE_STOPLEVEL))*Point;
   if (L3>=Bid-stlev) L3=Bid-stlev; 
   if (H3<=Ask+stlev) H3=Ask+stlev; 
   for (i = 0; i < OrdersTotal(); i++) {
      if ( OrderSelect (i, SELECT_BY_POS) == false )  continue;
      if ( OrderSymbol() != Symbol() || OrderMagicNumber() != expertId )  continue;
      if ( OrderType() == OP_BUY ) {
         StopLoss = L3;
         if ( StopLoss > OrderStopLoss() ) {
               bres=OrderModify (OrderTicket(), OrderOpenPrice(), StopLoss, OrderTakeProfit(), 0, White);
				   if (!bres) Print("Error Modifying BUY order : ",ErrorDescription(GetLastError()));
         }
      }

      if ( OrderType() == OP_SELL ) {
         StopLoss = H3;
         if ( StopLoss < OrderStopLoss() || OrderStopLoss()<Point ) {
               bres=OrderModify (OrderTicket(), OrderOpenPrice(), StopLoss, OrderTakeProfit(), 0, Gold);
				   if (!bres) Print("Error Modifying SELL order : ",ErrorDescription(GetLastError()));
         }
      }
   }
}

//+------------------------------------------------------------------+
//| Start function                                                   |
//+------------------------------------------------------------------+
void start()  {

   //---- check for history and trading
     if (UseHourTrade){
   if((Hour()>=FromHourTrade)&&(Hour()<=ToHourTrade))
      Comment("Trading Hours");
   else
     {
      Comment("Non-trading Hours");
      return(0);
     }
   }
   
   if(Bars<100 || IsTradeAllowed()==false) return;

   co=CalculateCurrentOrders(Symbol());

   CheckForSignals();
   if (co>0) CheckForClose();
   CheckForOpen();
   
   co=CalculateCurrentOrders(Symbol());

   if (mkt>0) {
      BreakEvenStop(BreakEven,0);
      Trail3Bar();
   }
       
}
   

   
   
   


